﻿using System;
using System.Windows.Forms;
using Asgard3.Core.Database;

namespace DatabaseManagement
{
    public partial class DBManager : Form
    {
        Main Me;
        DbUser SelectedUser;
        public DBManager(Main m)
        {
            InitializeComponent();
            Me = m;
        }

        private void DBManager_Load(object sender, EventArgs e)
        {
            foreach (DbUser u in Me.Host.UserDatabase.Users)
            {
                listBox1.Items.Add(string.Format("{0} {1}", u.Username, u.Flags.ToString().Replace(" ", null).Replace(",", null)));
            }
        }

        void Deny()
        {
            btnEdit.Enabled = false;
            btnRemove.Enabled = false;
            listBox1.Enabled = false;
        }

        void Allow()
        {
            SelectedUser = null;
            btnEdit.Enabled = true;
            btnRemove.Enabled = true;
            listBox1.Enabled = true;
            txtUsername.Text = null;
            txtFlags.Text = null;
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (listBox1.SelectedItem == null)
                return;

            SelectedUser = Me.Host.UserDatabase.Users[listBox1.SelectedIndex];

            txtUsername.Text = SelectedUser.Username;
            txtFlags.Text = SelectedUser.Flags.ToString().Replace(" ", null).Replace(",", null);

            Deny();
        }

        private void btnRemove_Click(object sender, EventArgs e)
        {
            if (listBox1.SelectedItem == null)
                return;

            Me.Host.UserDatabase.Users.RemoveAt(listBox1.SelectedIndex);
            listBox1.Items.RemoveAt(listBox1.SelectedIndex);
        }

        private void btnUpdate_Click(object sender, EventArgs e)
        {
            if (SelectedUser != null)
            {
                SelectedUser.Username = txtUsername.Text;
                SelectedUser.Flags = Me.Host.UserDatabase.StringToFlags(txtFlags.Text);
                listBox1.Items[listBox1.SelectedIndex] = string.Format("{0} {1}", SelectedUser.Username, SelectedUser.Flags.ToString().Replace(" ", null).Replace(",", null));
                Me.Host.UserDatabase.Users[listBox1.SelectedIndex] = SelectedUser;
                Allow();
            }
            else
            {
                Me.Host.UserDatabase.AddUser(txtUsername.Text, "Asgard 3", Me.Host.UserDatabase.StringToFlags(txtFlags.Text));
                SelectedUser = Me.Host.UserDatabase.FindUser(txtUsername.Text);
                listBox1.Items.Add(string.Format("{0} {1}", SelectedUser.Username, SelectedUser.Flags.ToString().Replace(" ", null).Replace(",", null)));
                Allow();
            }
        }

        private void btnDone_Click(object sender, EventArgs e)
        {
            Me.Host.UserDatabase.Save();
            this.Close();
        }
    }
}
