﻿using System;
using System.Drawing;
using System.Windows.Forms;
using Asgard3.Core.Database;
using Asgard3.Core.Plugin;

namespace DatabaseManagement
{
    public class Main : IPlugin
    {
        public ToolStripMenuItem myMenu = new ToolStripMenuItem();
        public DBManager db;

        public IHost Host;

        #region IPlugin Members

        public string Author
        {
            get { return "Mike@USWest"; }
        }

        public string Name
        {
            get { return "Database Management"; }
        }

        public string Description
        {
            get { return "A plugin which allows for database management."; }
        }

        public string Filename
        {
            get { return "DatabaseManagement.dll"; }
        }

        public string URL
        {
            get { return @"http://www.mikeownage.com/downloads/asgard3/DatabaseManagement.dll"; }
        }

        public void Initialize(IHost host)
        {
            Host = host;
            host.UserDatabase.HandleDatabaseMessage += new UserDatabaseList.DelDatabaseHandle(UserDatabase_HandleDatabaseMessage);

            EventHandler e = new EventHandler(myMenus_Click);
            myMenu.Text = "Database Manager";
            myMenu.DropDownItems.Add(PluginFunctions.NewToolMenu("ManageDatabase", "Manage Database", e));
            myMenu.DropDownItems.Add(PluginFunctions.NewToolMenu("Unload", "Unload Me", e));
            Host.SetPluginMenu(myMenu);
        }

        void UserDatabase_HandleDatabaseMessage(string message)
        {
            Host.UserDatabase.HandleDatabaseMessage -= UserDatabase_HandleDatabaseMessage;
            Host.AddChat(Color.Red, string.Format("Database Error: {0}", message));
        }

        public void Unload()
        {
            Host.UnloadPlugin();
        }

        void myMenus_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem m = (ToolStripMenuItem)sender;
            switch (m.Name)
            {
                case "ManageDatabase":
                    if (db == null)
                    {
                        db = new DBManager(this);
                        Host.ShowForm(db);
                    }
                    if (db.IsDisposed)
                    {
                        db = new DBManager(this);
                        Host.ShowForm(db);
                    }
                    break;
                case "Unload":
                    Unload();
                    break;
            }
        }

        #endregion
    }
}
